(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require HighOrd.
Require int.Int.
Require int.Abs.
Require int.EuclideanDivision.
Require int.NumOf.
Require bool.Bool.
Require map.Map.
Require map.Const.
Require bv.Pow2int.
Require bv.BV_Gen.

Parameter sum:
  (Numbers.BinNums.Z -> Numbers.BinNums.Z) -> Numbers.BinNums.Z ->
  Numbers.BinNums.Z -> Numbers.BinNums.Z.

Axiom sum'def :
  forall (f:Numbers.BinNums.Z -> Numbers.BinNums.Z) (a:Numbers.BinNums.Z)
    (b:Numbers.BinNums.Z),
  ((b <= a)%Z -> ((sum f a b) = 0%Z)) /\
  (~ (b <= a)%Z ->
   ((sum f a b) = ((sum f a (b - 1%Z)%Z) + (f (b - 1%Z)%Z))%Z)).

Axiom sum_left :
  forall (f:Numbers.BinNums.Z -> Numbers.BinNums.Z) (a:Numbers.BinNums.Z)
    (b:Numbers.BinNums.Z),
  (a < b)%Z -> ((sum f a b) = ((f a) + (sum f (a + 1%Z)%Z b))%Z).

Axiom sum_ext :
  forall (f:Numbers.BinNums.Z -> Numbers.BinNums.Z)
    (g:Numbers.BinNums.Z -> Numbers.BinNums.Z) (a:Numbers.BinNums.Z)
    (b:Numbers.BinNums.Z),
  (forall (i:Numbers.BinNums.Z), (a <= i)%Z /\ (i < b)%Z -> ((f i) = (g i))) ->
  ((sum f a b) = (sum g a b)).

Axiom sum_le :
  forall (f:Numbers.BinNums.Z -> Numbers.BinNums.Z)
    (g:Numbers.BinNums.Z -> Numbers.BinNums.Z) (a:Numbers.BinNums.Z)
    (b:Numbers.BinNums.Z),
  (forall (i:Numbers.BinNums.Z), (a <= i)%Z /\ (i < b)%Z ->
   ((f i) <= (g i))%Z) ->
  ((sum f a b) <= (sum g a b))%Z.

Axiom sum_zero :
  forall (f:Numbers.BinNums.Z -> Numbers.BinNums.Z) (a:Numbers.BinNums.Z)
    (b:Numbers.BinNums.Z),
  (forall (i:Numbers.BinNums.Z), (a <= i)%Z /\ (i < b)%Z -> ((f i) = 0%Z)) ->
  ((sum f a b) = 0%Z).

Axiom sum_nonneg :
  forall (f:Numbers.BinNums.Z -> Numbers.BinNums.Z) (a:Numbers.BinNums.Z)
    (b:Numbers.BinNums.Z),
  (forall (i:Numbers.BinNums.Z), (a <= i)%Z /\ (i < b)%Z -> (0%Z <= (f i))%Z) ->
  (0%Z <= (sum f a b))%Z.

Axiom sum_decomp :
  forall (f:Numbers.BinNums.Z -> Numbers.BinNums.Z) (a:Numbers.BinNums.Z)
    (b:Numbers.BinNums.Z) (c:Numbers.BinNums.Z),
  (a <= b)%Z /\ (b <= c)%Z -> ((sum f a c) = ((sum f a b) + (sum f b c))%Z).

Axiom shift_left :
  forall (f:Numbers.BinNums.Z -> Numbers.BinNums.Z)
    (g:Numbers.BinNums.Z -> Numbers.BinNums.Z) (a:Numbers.BinNums.Z)
    (b:Numbers.BinNums.Z) (c:Numbers.BinNums.Z) (d:Numbers.BinNums.Z),
  ((b - a)%Z = (d - c)%Z) ->
  (forall (i:Numbers.BinNums.Z), (a <= i)%Z /\ (i < b)%Z ->
   ((f i) = (g ((c + i)%Z - a)%Z))) ->
  ((sum f a b) = (sum g c d)).

Axiom array : forall (a:Type), Type.
Parameter array_WhyType :
  forall (a:Type) {a_WT:WhyType a}, WhyType (array a).
Existing Instance array_WhyType.

Parameter elts:
  forall {a:Type} {a_WT:WhyType a}, array a -> Numbers.BinNums.Z -> a.

Parameter length:
  forall {a:Type} {a_WT:WhyType a}, array a -> Numbers.BinNums.Z.

Axiom array'invariant :
  forall {a:Type} {a_WT:WhyType a},
  forall (self:array a), (0%Z <= (length self))%Z.

(* Why3 assumption *)
Definition mixfix_lbrb {a:Type} {a_WT:WhyType a} (a1:array a)
    (i:Numbers.BinNums.Z) : a :=
  elts a1 i.

Parameter mixfix_lblsmnrb:
  forall {a:Type} {a_WT:WhyType a}, array a -> Numbers.BinNums.Z -> a ->
  array a.

Axiom mixfix_lblsmnrb'spec :
  forall {a:Type} {a_WT:WhyType a},
  forall (a1:array a) (i:Numbers.BinNums.Z) (v:a),
  ((length (mixfix_lblsmnrb a1 i v)) = (length a1)) /\
  ((elts (mixfix_lblsmnrb a1 i v)) = (map.Map.set (elts a1) i v)).

Parameter make:
  forall {a:Type} {a_WT:WhyType a}, Numbers.BinNums.Z -> a -> array a.

Axiom make'spec :
  forall {a:Type} {a_WT:WhyType a},
  forall (n:Numbers.BinNums.Z) (v:a), (0%Z <= n)%Z ->
  (forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i < n)%Z ->
   ((mixfix_lbrb (make n v) i) = v)) /\
  ((length (make n v)) = n).

(* Why3 assumption *)
Definition sum1 (a:array Numbers.BinNums.Z) (l:Numbers.BinNums.Z)
    (h:Numbers.BinNums.Z) : Numbers.BinNums.Z :=
  sum (elts a) l h.

Axiom t : Type.
Parameter t_WhyType : WhyType t.
Existing Instance t_WhyType.

Parameter t'int: t -> Numbers.BinNums.Z.

Axiom t'axiom : forall (i:t), (0%Z <= (t'int i))%Z /\ ((t'int i) <= 255%Z)%Z.

Parameter nth: t -> Numbers.BinNums.Z -> Init.Datatypes.bool.

Axiom nth_out_of_bound :
  forall (x:t) (n:Numbers.BinNums.Z), (n < 0%Z)%Z \/ (8%Z <= n)%Z ->
  ((nth x n) = Init.Datatypes.false).

Parameter zeros: t.

Axiom Nth_zeros :
  forall (n:Numbers.BinNums.Z), ((nth zeros n) = Init.Datatypes.false).

Parameter one: t.

Parameter ones: t.

Axiom Nth_ones :
  forall (n:Numbers.BinNums.Z), (0%Z <= n)%Z /\ (n < 8%Z)%Z ->
  ((nth ones n) = Init.Datatypes.true).

Parameter bw_and: t -> t -> t.

Axiom Nth_bw_and :
  forall (v1:t) (v2:t) (n:Numbers.BinNums.Z), (0%Z <= n)%Z /\ (n < 8%Z)%Z ->
  ((nth (bw_and v1 v2) n) = (Init.Datatypes.andb (nth v1 n) (nth v2 n))).

Parameter bw_or: t -> t -> t.

Axiom Nth_bw_or :
  forall (v1:t) (v2:t) (n:Numbers.BinNums.Z), (0%Z <= n)%Z /\ (n < 8%Z)%Z ->
  ((nth (bw_or v1 v2) n) = (Init.Datatypes.orb (nth v1 n) (nth v2 n))).

Parameter bw_xor: t -> t -> t.

Axiom Nth_bw_xor :
  forall (v1:t) (v2:t) (n:Numbers.BinNums.Z), (0%Z <= n)%Z /\ (n < 8%Z)%Z ->
  ((nth (bw_xor v1 v2) n) = (Init.Datatypes.xorb (nth v1 n) (nth v2 n))).

Parameter bw_not: t -> t.

Axiom Nth_bw_not :
  forall (v:t) (n:Numbers.BinNums.Z), (0%Z <= n)%Z /\ (n < 8%Z)%Z ->
  ((nth (bw_not v) n) = (Init.Datatypes.negb (nth v n))).

Parameter lsr: t -> Numbers.BinNums.Z -> t.

Axiom Lsr_nth_low :
  forall (b:t) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z), (0%Z <= s)%Z ->
  (0%Z <= n)%Z -> ((n + s)%Z < 8%Z)%Z ->
  ((nth (lsr b s) n) = (nth b (n + s)%Z)).

Axiom Lsr_nth_high :
  forall (b:t) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z), (0%Z <= s)%Z ->
  (0%Z <= n)%Z -> (8%Z <= (n + s)%Z)%Z ->
  ((nth (lsr b s) n) = Init.Datatypes.false).

Axiom lsr_zeros : forall (x:t), ((lsr x 0%Z) = x).

Parameter asr: t -> Numbers.BinNums.Z -> t.

Axiom Asr_nth_low :
  forall (b:t) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z), (0%Z <= s)%Z ->
  (0%Z <= n)%Z /\ (n < 8%Z)%Z -> ((n + s)%Z < 8%Z)%Z ->
  ((nth (asr b s) n) = (nth b (n + s)%Z)).

Axiom Asr_nth_high :
  forall (b:t) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z), (0%Z <= s)%Z ->
  (0%Z <= n)%Z /\ (n < 8%Z)%Z -> (8%Z <= (n + s)%Z)%Z ->
  ((nth (asr b s) n) = (nth b (8%Z - 1%Z)%Z)).

Axiom asr_zeros : forall (x:t), ((asr x 0%Z) = x).

Parameter lsl: t -> Numbers.BinNums.Z -> t.

Axiom Lsl_nth_high :
  forall (b:t) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z),
  (0%Z <= s)%Z /\ (s <= n)%Z /\ (n < 8%Z)%Z ->
  ((nth (lsl b s) n) = (nth b (n - s)%Z)).

Axiom Lsl_nth_low :
  forall (b:t) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z),
  (0%Z <= n)%Z /\ (n < s)%Z -> ((nth (lsl b s) n) = Init.Datatypes.false).

Axiom lsl_zeros : forall (x:t), ((lsl x 0%Z) = x).

Parameter rotate_right: t -> Numbers.BinNums.Z -> t.

Axiom Nth_rotate_right :
  forall (v:t) (n:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 8%Z)%Z -> (0%Z <= n)%Z ->
  ((nth (rotate_right v n) i) =
   (nth v (int.EuclideanDivision.mod1 (i + n)%Z 8%Z))).

Parameter rotate_left: t -> Numbers.BinNums.Z -> t.

Axiom Nth_rotate_left :
  forall (v:t) (n:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 8%Z)%Z -> (0%Z <= n)%Z ->
  ((nth (rotate_left v n) i) =
   (nth v (int.EuclideanDivision.mod1 (i - n)%Z 8%Z))).

Parameter is_signed_positive: t -> Prop.

Parameter of_int: Numbers.BinNums.Z -> t.

Parameter to_int: t -> Numbers.BinNums.Z.

Axiom to_int'def :
  forall (x:t),
  (is_signed_positive x -> ((to_int x) = (t'int x))) /\
  (~ is_signed_positive x -> ((to_int x) = (-(256%Z - (t'int x))%Z)%Z)).

Axiom to_uint_extensionality :
  forall (v:t) (v':t), ((t'int v) = (t'int v')) -> (v = v').

Axiom to_int_extensionality :
  forall (v:t) (v':t), ((to_int v) = (to_int v')) -> (v = v').

(* Why3 assumption *)
Definition uint_in_range (i:Numbers.BinNums.Z) : Prop :=
  (0%Z <= i)%Z /\ (i <= 255%Z)%Z.

Axiom to_uint_bounds :
  forall (v:t), (0%Z <= (t'int v))%Z /\ ((t'int v) < 256%Z)%Z.

Axiom to_uint_of_int :
  forall (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i < 256%Z)%Z ->
  ((t'int (of_int i)) = i).

Parameter size_bv: t.

Axiom to_uint_size_bv : ((t'int size_bv) = 8%Z).

Axiom to_uint_zeros : ((t'int zeros) = 0%Z).

Axiom to_uint_one : ((t'int one) = 1%Z).

Axiom to_uint_ones : ((t'int ones) = 255%Z).

(* Why3 assumption *)
Definition ult (x:t) (y:t) : Prop := ((t'int x) < (t'int y))%Z.

(* Why3 assumption *)
Definition ule (x:t) (y:t) : Prop := ((t'int x) <= (t'int y))%Z.

(* Why3 assumption *)
Definition ugt (x:t) (y:t) : Prop := ((t'int y) < (t'int x))%Z.

(* Why3 assumption *)
Definition uge (x:t) (y:t) : Prop := ((t'int y) <= (t'int x))%Z.

(* Why3 assumption *)
Definition slt (v1:t) (v2:t) : Prop := ((to_int v1) < (to_int v2))%Z.

(* Why3 assumption *)
Definition sle (v1:t) (v2:t) : Prop := ((to_int v1) <= (to_int v2))%Z.

(* Why3 assumption *)
Definition sgt (v1:t) (v2:t) : Prop := ((to_int v2) < (to_int v1))%Z.

(* Why3 assumption *)
Definition sge (v1:t) (v2:t) : Prop := ((to_int v2) <= (to_int v1))%Z.

Axiom positive_is_ge_zeros :
  forall (x:t), is_signed_positive x <-> sge x zeros.

Parameter add: t -> t -> t.

Axiom to_uint_add :
  forall (v1:t) (v2:t),
  ((t'int (add v1 v2)) =
   (int.EuclideanDivision.mod1 ((t'int v1) + (t'int v2))%Z 256%Z)).

Axiom to_uint_add_bounded :
  forall (v1:t) (v2:t), (((t'int v1) + (t'int v2))%Z < 256%Z)%Z ->
  ((t'int (add v1 v2)) = ((t'int v1) + (t'int v2))%Z).

Parameter sub: t -> t -> t.

Axiom to_uint_sub :
  forall (v1:t) (v2:t),
  ((t'int (sub v1 v2)) =
   (int.EuclideanDivision.mod1 ((t'int v1) - (t'int v2))%Z 256%Z)).

Axiom to_uint_sub_bounded :
  forall (v1:t) (v2:t),
  (0%Z <= ((t'int v1) - (t'int v2))%Z)%Z /\
  (((t'int v1) - (t'int v2))%Z < 256%Z)%Z ->
  ((t'int (sub v1 v2)) = ((t'int v1) - (t'int v2))%Z).

Parameter neg: t -> t.

Axiom to_uint_neg :
  forall (v:t),
  ((t'int (neg v)) = (int.EuclideanDivision.mod1 (-(t'int v))%Z 256%Z)).

Parameter mul: t -> t -> t.

Axiom to_uint_mul :
  forall (v1:t) (v2:t),
  ((t'int (mul v1 v2)) =
   (int.EuclideanDivision.mod1 ((t'int v1) * (t'int v2))%Z 256%Z)).

Axiom to_uint_mul_bounded :
  forall (v1:t) (v2:t), (((t'int v1) * (t'int v2))%Z < 256%Z)%Z ->
  ((t'int (mul v1 v2)) = ((t'int v1) * (t'int v2))%Z).

Parameter udiv: t -> t -> t.

Axiom to_uint_udiv :
  forall (v1:t) (v2:t),
  ((t'int (udiv v1 v2)) = (int.EuclideanDivision.div (t'int v1) (t'int v2))).

Parameter urem: t -> t -> t.

Axiom to_uint_urem :
  forall (v1:t) (v2:t),
  ((t'int (urem v1 v2)) = (int.EuclideanDivision.mod1 (t'int v1) (t'int v2))).

Parameter lsr_bv: t -> t -> t.

Axiom lsr_bv_is_lsr : forall (x:t) (n:t), ((lsr_bv x n) = (lsr x (t'int n))).

Axiom to_uint_lsr :
  forall (v:t) (n:t),
  ((t'int (lsr_bv v n)) =
   (int.EuclideanDivision.div (t'int v) (bv.Pow2int.pow2 (t'int n)))).

Parameter asr_bv: t -> t -> t.

Axiom asr_bv_is_asr : forall (x:t) (n:t), ((asr_bv x n) = (asr x (t'int n))).

Parameter lsl_bv: t -> t -> t.

Axiom lsl_bv_is_lsl : forall (x:t) (n:t), ((lsl_bv x n) = (lsl x (t'int n))).

Axiom to_uint_lsl :
  forall (v:t) (n:t),
  ((t'int (lsl_bv v n)) =
   (int.EuclideanDivision.mod1 ((t'int v) * (bv.Pow2int.pow2 (t'int n)))%Z
    256%Z)).

Parameter rotate_right_bv: t -> t -> t.

Parameter rotate_left_bv: t -> t -> t.

Axiom rotate_left_bv_is_rotate_left :
  forall (v:t) (n:t), ((rotate_left_bv v n) = (rotate_left v (t'int n))).

Axiom rotate_right_bv_is_rotate_right :
  forall (v:t) (n:t), ((rotate_right_bv v n) = (rotate_right v (t'int n))).

Parameter nth_bv: t -> t -> Init.Datatypes.bool.

Axiom nth_bv_def :
  forall (x:t) (i:t),
  ((nth_bv x i) = Init.Datatypes.true) <->
  ~ ((bw_and (lsr_bv x i) one) = zeros).

Axiom Nth_bv_is_nth : forall (x:t) (i:t), ((nth x (t'int i)) = (nth_bv x i)).

Axiom Nth_bv_is_nth2 :
  forall (x:t) (i:Numbers.BinNums.Z), (0%Z <= i)%Z /\ (i < 256%Z)%Z ->
  ((nth_bv x (of_int i)) = (nth x i)).

Parameter eq_sub_bv: t -> t -> t -> t -> Prop.

Axiom eq_sub_bv_def :
  forall (a:t) (b:t) (i:t) (n:t),
  let mask := lsl_bv (sub (lsl_bv one n) one) i in
  eq_sub_bv a b i n <-> ((bw_and b mask) = (bw_and a mask)).

(* Why3 assumption *)
Definition eq_sub (a:t) (b:t) (i:Numbers.BinNums.Z) (n:Numbers.BinNums.Z) :
    Prop :=
  forall (j:Numbers.BinNums.Z), (i <= j)%Z /\ (j < (i + n)%Z)%Z ->
  ((nth a j) = (nth b j)).

Axiom eq_sub_equiv :
  forall (a:t) (b:t) (i:t) (n:t),
  eq_sub a b (t'int i) (t'int n) <-> eq_sub_bv a b i n.

Axiom Extensionality : forall (x:t) (y:t), eq_sub x y 0%Z 8%Z -> (x = y).

Axiom t1 : Type.
Parameter t1_WhyType : WhyType t1.
Existing Instance t1_WhyType.

Parameter t'int1: t1 -> Numbers.BinNums.Z.

Axiom t'axiom1 :
  forall (i:t1),
  (0%Z <= (t'int1 i))%Z /\ ((t'int1 i) <= 18446744073709551615%Z)%Z.

Parameter nth1: t1 -> Numbers.BinNums.Z -> Init.Datatypes.bool.

Axiom nth_out_of_bound1 :
  forall (x:t1) (n:Numbers.BinNums.Z), (n < 0%Z)%Z \/ (64%Z <= n)%Z ->
  ((nth1 x n) = Init.Datatypes.false).

Parameter zeros1: t1.

Axiom Nth_zeros1 :
  forall (n:Numbers.BinNums.Z), ((nth1 zeros1 n) = Init.Datatypes.false).

Parameter one1: t1.

Parameter ones1: t1.

Axiom Nth_ones1 :
  forall (n:Numbers.BinNums.Z), (0%Z <= n)%Z /\ (n < 64%Z)%Z ->
  ((nth1 ones1 n) = Init.Datatypes.true).

Parameter bw_and1: t1 -> t1 -> t1.

Axiom Nth_bw_and1 :
  forall (v1:t1) (v2:t1) (n:Numbers.BinNums.Z),
  (0%Z <= n)%Z /\ (n < 64%Z)%Z ->
  ((nth1 (bw_and1 v1 v2) n) = (Init.Datatypes.andb (nth1 v1 n) (nth1 v2 n))).

Parameter bw_or1: t1 -> t1 -> t1.

Axiom Nth_bw_or1 :
  forall (v1:t1) (v2:t1) (n:Numbers.BinNums.Z),
  (0%Z <= n)%Z /\ (n < 64%Z)%Z ->
  ((nth1 (bw_or1 v1 v2) n) = (Init.Datatypes.orb (nth1 v1 n) (nth1 v2 n))).

Parameter bw_xor1: t1 -> t1 -> t1.

Axiom Nth_bw_xor1 :
  forall (v1:t1) (v2:t1) (n:Numbers.BinNums.Z),
  (0%Z <= n)%Z /\ (n < 64%Z)%Z ->
  ((nth1 (bw_xor1 v1 v2) n) = (Init.Datatypes.xorb (nth1 v1 n) (nth1 v2 n))).

Parameter bw_not1: t1 -> t1.

Axiom Nth_bw_not1 :
  forall (v:t1) (n:Numbers.BinNums.Z), (0%Z <= n)%Z /\ (n < 64%Z)%Z ->
  ((nth1 (bw_not1 v) n) = (Init.Datatypes.negb (nth1 v n))).

Parameter lsr1: t1 -> Numbers.BinNums.Z -> t1.

Axiom Lsr_nth_low1 :
  forall (b:t1) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z), (0%Z <= s)%Z ->
  (0%Z <= n)%Z -> ((n + s)%Z < 64%Z)%Z ->
  ((nth1 (lsr1 b s) n) = (nth1 b (n + s)%Z)).

Axiom Lsr_nth_high1 :
  forall (b:t1) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z), (0%Z <= s)%Z ->
  (0%Z <= n)%Z -> (64%Z <= (n + s)%Z)%Z ->
  ((nth1 (lsr1 b s) n) = Init.Datatypes.false).

Axiom lsr_zeros1 : forall (x:t1), ((lsr1 x 0%Z) = x).

Parameter asr1: t1 -> Numbers.BinNums.Z -> t1.

Axiom Asr_nth_low1 :
  forall (b:t1) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z), (0%Z <= s)%Z ->
  (0%Z <= n)%Z /\ (n < 64%Z)%Z -> ((n + s)%Z < 64%Z)%Z ->
  ((nth1 (asr1 b s) n) = (nth1 b (n + s)%Z)).

Axiom Asr_nth_high1 :
  forall (b:t1) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z), (0%Z <= s)%Z ->
  (0%Z <= n)%Z /\ (n < 64%Z)%Z -> (64%Z <= (n + s)%Z)%Z ->
  ((nth1 (asr1 b s) n) = (nth1 b (64%Z - 1%Z)%Z)).

Axiom asr_zeros1 : forall (x:t1), ((asr1 x 0%Z) = x).

Parameter lsl1: t1 -> Numbers.BinNums.Z -> t1.

Axiom Lsl_nth_high1 :
  forall (b:t1) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z),
  (0%Z <= s)%Z /\ (s <= n)%Z /\ (n < 64%Z)%Z ->
  ((nth1 (lsl1 b s) n) = (nth1 b (n - s)%Z)).

Axiom Lsl_nth_low1 :
  forall (b:t1) (n:Numbers.BinNums.Z) (s:Numbers.BinNums.Z),
  (0%Z <= n)%Z /\ (n < s)%Z -> ((nth1 (lsl1 b s) n) = Init.Datatypes.false).

Axiom lsl_zeros1 : forall (x:t1), ((lsl1 x 0%Z) = x).

Parameter rotate_right1: t1 -> Numbers.BinNums.Z -> t1.

Axiom Nth_rotate_right1 :
  forall (v:t1) (n:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 64%Z)%Z -> (0%Z <= n)%Z ->
  ((nth1 (rotate_right1 v n) i) =
   (nth1 v (int.EuclideanDivision.mod1 (i + n)%Z 64%Z))).

Parameter rotate_left1: t1 -> Numbers.BinNums.Z -> t1.

Axiom Nth_rotate_left1 :
  forall (v:t1) (n:Numbers.BinNums.Z) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 64%Z)%Z -> (0%Z <= n)%Z ->
  ((nth1 (rotate_left1 v n) i) =
   (nth1 v (int.EuclideanDivision.mod1 (i - n)%Z 64%Z))).

Parameter is_signed_positive1: t1 -> Prop.

Parameter of_int1: Numbers.BinNums.Z -> t1.

Parameter to_int1: t1 -> Numbers.BinNums.Z.

Axiom to_int'def1 :
  forall (x:t1),
  (is_signed_positive1 x -> ((to_int1 x) = (t'int1 x))) /\
  (~ is_signed_positive1 x ->
   ((to_int1 x) = (-(18446744073709551616%Z - (t'int1 x))%Z)%Z)).

Axiom to_uint_extensionality1 :
  forall (v:t1) (v':t1), ((t'int1 v) = (t'int1 v')) -> (v = v').

Axiom to_int_extensionality1 :
  forall (v:t1) (v':t1), ((to_int1 v) = (to_int1 v')) -> (v = v').

(* Why3 assumption *)
Definition uint_in_range1 (i:Numbers.BinNums.Z) : Prop :=
  (0%Z <= i)%Z /\ (i <= 18446744073709551615%Z)%Z.

Axiom to_uint_bounds1 :
  forall (v:t1),
  (0%Z <= (t'int1 v))%Z /\ ((t'int1 v) < 18446744073709551616%Z)%Z.

Axiom to_uint_of_int1 :
  forall (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 18446744073709551616%Z)%Z ->
  ((t'int1 (of_int1 i)) = i).

Parameter size_bv1: t1.

Axiom to_uint_size_bv1 : ((t'int1 size_bv1) = 64%Z).

Axiom to_uint_zeros1 : ((t'int1 zeros1) = 0%Z).

Axiom to_uint_one1 : ((t'int1 one1) = 1%Z).

Axiom to_uint_ones1 : ((t'int1 ones1) = 18446744073709551615%Z).

(* Why3 assumption *)
Definition ult1 (x:t1) (y:t1) : Prop := ((t'int1 x) < (t'int1 y))%Z.

(* Why3 assumption *)
Definition ule1 (x:t1) (y:t1) : Prop := ((t'int1 x) <= (t'int1 y))%Z.

(* Why3 assumption *)
Definition ugt1 (x:t1) (y:t1) : Prop := ((t'int1 y) < (t'int1 x))%Z.

(* Why3 assumption *)
Definition uge1 (x:t1) (y:t1) : Prop := ((t'int1 y) <= (t'int1 x))%Z.

(* Why3 assumption *)
Definition slt1 (v1:t1) (v2:t1) : Prop := ((to_int1 v1) < (to_int1 v2))%Z.

(* Why3 assumption *)
Definition sle1 (v1:t1) (v2:t1) : Prop := ((to_int1 v1) <= (to_int1 v2))%Z.

(* Why3 assumption *)
Definition sgt1 (v1:t1) (v2:t1) : Prop := ((to_int1 v2) < (to_int1 v1))%Z.

(* Why3 assumption *)
Definition sge1 (v1:t1) (v2:t1) : Prop := ((to_int1 v2) <= (to_int1 v1))%Z.

Axiom positive_is_ge_zeros1 :
  forall (x:t1), is_signed_positive1 x <-> sge1 x zeros1.

Parameter add1: t1 -> t1 -> t1.

Axiom to_uint_add1 :
  forall (v1:t1) (v2:t1),
  ((t'int1 (add1 v1 v2)) =
   (int.EuclideanDivision.mod1 ((t'int1 v1) + (t'int1 v2))%Z
    18446744073709551616%Z)).

Axiom to_uint_add_bounded1 :
  forall (v1:t1) (v2:t1),
  (((t'int1 v1) + (t'int1 v2))%Z < 18446744073709551616%Z)%Z ->
  ((t'int1 (add1 v1 v2)) = ((t'int1 v1) + (t'int1 v2))%Z).

Parameter sub1: t1 -> t1 -> t1.

Axiom to_uint_sub1 :
  forall (v1:t1) (v2:t1),
  ((t'int1 (sub1 v1 v2)) =
   (int.EuclideanDivision.mod1 ((t'int1 v1) - (t'int1 v2))%Z
    18446744073709551616%Z)).

Axiom to_uint_sub_bounded1 :
  forall (v1:t1) (v2:t1),
  (0%Z <= ((t'int1 v1) - (t'int1 v2))%Z)%Z /\
  (((t'int1 v1) - (t'int1 v2))%Z < 18446744073709551616%Z)%Z ->
  ((t'int1 (sub1 v1 v2)) = ((t'int1 v1) - (t'int1 v2))%Z).

Parameter neg1: t1 -> t1.

Axiom to_uint_neg1 :
  forall (v:t1),
  ((t'int1 (neg1 v)) =
   (int.EuclideanDivision.mod1 (-(t'int1 v))%Z 18446744073709551616%Z)).

Parameter mul1: t1 -> t1 -> t1.

Axiom to_uint_mul1 :
  forall (v1:t1) (v2:t1),
  ((t'int1 (mul1 v1 v2)) =
   (int.EuclideanDivision.mod1 ((t'int1 v1) * (t'int1 v2))%Z
    18446744073709551616%Z)).

Axiom to_uint_mul_bounded1 :
  forall (v1:t1) (v2:t1),
  (((t'int1 v1) * (t'int1 v2))%Z < 18446744073709551616%Z)%Z ->
  ((t'int1 (mul1 v1 v2)) = ((t'int1 v1) * (t'int1 v2))%Z).

Parameter udiv1: t1 -> t1 -> t1.

Axiom to_uint_udiv1 :
  forall (v1:t1) (v2:t1),
  ((t'int1 (udiv1 v1 v2)) =
   (int.EuclideanDivision.div (t'int1 v1) (t'int1 v2))).

Parameter urem1: t1 -> t1 -> t1.

Axiom to_uint_urem1 :
  forall (v1:t1) (v2:t1),
  ((t'int1 (urem1 v1 v2)) =
   (int.EuclideanDivision.mod1 (t'int1 v1) (t'int1 v2))).

Parameter lsr_bv1: t1 -> t1 -> t1.

Axiom lsr_bv_is_lsr1 :
  forall (x:t1) (n:t1), ((lsr_bv1 x n) = (lsr1 x (t'int1 n))).

Axiom to_uint_lsr1 :
  forall (v:t1) (n:t1),
  ((t'int1 (lsr_bv1 v n)) =
   (int.EuclideanDivision.div (t'int1 v) (bv.Pow2int.pow2 (t'int1 n)))).

Parameter asr_bv1: t1 -> t1 -> t1.

Axiom asr_bv_is_asr1 :
  forall (x:t1) (n:t1), ((asr_bv1 x n) = (asr1 x (t'int1 n))).

Parameter lsl_bv1: t1 -> t1 -> t1.

Axiom lsl_bv_is_lsl1 :
  forall (x:t1) (n:t1), ((lsl_bv1 x n) = (lsl1 x (t'int1 n))).

Axiom to_uint_lsl1 :
  forall (v:t1) (n:t1),
  ((t'int1 (lsl_bv1 v n)) =
   (int.EuclideanDivision.mod1 ((t'int1 v) * (bv.Pow2int.pow2 (t'int1 n)))%Z
    18446744073709551616%Z)).

Parameter rotate_right_bv1: t1 -> t1 -> t1.

Parameter rotate_left_bv1: t1 -> t1 -> t1.

Axiom rotate_left_bv_is_rotate_left1 :
  forall (v:t1) (n:t1), ((rotate_left_bv1 v n) = (rotate_left1 v (t'int1 n))).

Axiom rotate_right_bv_is_rotate_right1 :
  forall (v:t1) (n:t1),
  ((rotate_right_bv1 v n) = (rotate_right1 v (t'int1 n))).

Parameter nth_bv1: t1 -> t1 -> Init.Datatypes.bool.

Axiom nth_bv_def1 :
  forall (x:t1) (i:t1),
  ((nth_bv1 x i) = Init.Datatypes.true) <->
  ~ ((bw_and1 (lsr_bv1 x i) one1) = zeros1).

Axiom Nth_bv_is_nth1 :
  forall (x:t1) (i:t1), ((nth1 x (t'int1 i)) = (nth_bv1 x i)).

Axiom Nth_bv_is_nth21 :
  forall (x:t1) (i:Numbers.BinNums.Z),
  (0%Z <= i)%Z /\ (i < 18446744073709551616%Z)%Z ->
  ((nth_bv1 x (of_int1 i)) = (nth1 x i)).

Parameter eq_sub_bv1: t1 -> t1 -> t1 -> t1 -> Prop.

Axiom eq_sub_bv_def1 :
  forall (a:t1) (b:t1) (i:t1) (n:t1),
  let mask := lsl_bv1 (sub1 (lsl_bv1 one1 n) one1) i in
  eq_sub_bv1 a b i n <-> ((bw_and1 b mask) = (bw_and1 a mask)).

(* Why3 assumption *)
Definition eq_sub1 (a:t1) (b:t1) (i:Numbers.BinNums.Z)
    (n:Numbers.BinNums.Z) : Prop :=
  forall (j:Numbers.BinNums.Z), (i <= j)%Z /\ (j < (i + n)%Z)%Z ->
  ((nth1 a j) = (nth1 b j)).

Axiom eq_sub_equiv1 :
  forall (a:t1) (b:t1) (i:t1) (n:t1),
  eq_sub1 a b (t'int1 i) (t'int1 n) <-> eq_sub_bv1 a b i n.

Axiom Extensionality1 :
  forall (x:t1) (y:t1), eq_sub1 x y 0%Z 64%Z -> (x = y).

(* Why3 assumption *)
Definition int_t (v:Numbers.BinNums.Z) : Prop :=
  (((-((bv.Pow2int.pow2 ((4%Z * 8%Z)%Z - 1%Z)%Z) - 1%Z)%Z)%Z - 1%Z)%Z <= v)%Z /\
  (v <= ((bv.Pow2int.pow2 ((4%Z * 8%Z)%Z - 1%Z)%Z) - 1%Z)%Z)%Z.

(* Why3 assumption *)
Definition uint_t (v:Numbers.BinNums.Z) : Prop :=
  (0%Z <= v)%Z /\
  (v <= ((bv.Pow2int.pow2 ((4%Z * 8%Z)%Z - 1%Z)%Z) - 1%Z)%Z)%Z.

(* Why3 assumption *)
Definition long_t (v:Numbers.BinNums.Z) : Prop :=
  (((-((bv.Pow2int.pow2 (8%Z * 8%Z)%Z) - 1%Z)%Z)%Z - 1%Z)%Z <= v)%Z /\
  (v <= ((bv.Pow2int.pow2 (8%Z * 8%Z)%Z) - 1%Z)%Z)%Z.

(* Why3 assumption *)
Definition ulong_t (v:Numbers.BinNums.Z) : Prop :=
  (0%Z <= v)%Z /\
  (v <= ((((bv.Pow2int.pow2 (8%Z * 8%Z)%Z) - 1%Z)%Z * 2%Z)%Z + 1%Z)%Z)%Z.

(* Why3 assumption *)
Definition size_t (v:Numbers.BinNums.Z) : Prop :=
  (0%Z <= v)%Z /\ (v <= ((bv.Pow2int.pow2 (8%Z * 8%Z)%Z) - 1%Z)%Z)%Z.

(* Why3 assumption *)
Definition char_t (v:Numbers.BinNums.Z) : Prop :=
  (0%Z <= v)%Z /\ (v <= 255%Z)%Z.

(* Why3 assumption *)
Definition mem_t := array Numbers.BinNums.Z.

Parameter mem: array Numbers.BinNums.Z.

Parameter ptr: Numbers.BinNums.Z.

Parameter bytes: Numbers.BinNums.Z.

Axiom PtrType : size_t ptr.

Axiom BytesType : size_t bytes.

Axiom MemLimit : size_t (ptr + bytes)%Z.

Axiom Mem_array_char :
  forall (i:Numbers.BinNums.Z), size_t i -> char_t (mixfix_lbrb mem i).

Axiom Mem_length :
  ((length mem) = (((bv.Pow2int.pow2 (8%Z * 8%Z)%Z) - 1%Z)%Z + 1%Z)%Z).

(* Why3 assumption *)
Definition upper (p:Numbers.BinNums.Z) : Prop :=
  (ptr <= p)%Z /\
  ((int.EuclideanDivision.mod1 p 8%Z) = 0%Z) /\ ((p - ptr)%Z < 8%Z)%Z.

Axiom UniUpper :
  forall (x:Numbers.BinNums.Z) (y:Numbers.BinNums.Z), upper x /\ upper y ->
  (x = y).

Parameter ptrB: Numbers.BinNums.Z.

Axiom PtrB : upper ptrB.

Parameter ptrU: Numbers.BinNums.Z.

Axiom PtrU :
  (((ptr + bytes)%Z < ptrB)%Z -> (ptrU = (ptr + bytes)%Z)) /\
  (~ ((ptr + bytes)%Z < ptrB)%Z -> (ptrU = ptrB)).

Parameter bytesU: Numbers.BinNums.Z.

Axiom BytesU : (bytesU = (bytes - (ptrU - ptr)%Z)%Z).

Axiom BytesU_limit :
  ((int.EuclideanDivision.div bytesU 8%Z) <
   (int.EuclideanDivision.div
    ((bv.Pow2int.pow2 ((4%Z * 8%Z)%Z - 1%Z)%Z) - 1%Z)%Z (8%Z * 8%Z)%Z))%Z.

Parameter longW: Numbers.BinNums.Z.

Axiom LongW : (longW = (int.EuclideanDivision.div bytesU 8%Z)).

Parameter ptrT: Numbers.BinNums.Z.

Axiom PtrW : (ptrT = (ptrU + (longW * 8%Z)%Z)%Z).

Parameter bytesT: Numbers.BinNums.Z.

Axiom BytesW : (bytesT = (bytes - (ptrT - ptr)%Z)%Z).

Axiom BytesW_lt_wsize : (bytesT < 8%Z)%Z.

Axiom PtrW_ : (ptrU < ptrB)%Z -> (ptrT = ptrU).

Parameter bytew: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Axiom bytew'def :
  forall (b:Numbers.BinNums.Z), char_t b ->
  ((bytew b) =
   (int.NumOf.numof
    ((fun (y0:t) (y1:Numbers.BinNums.Z) => nth y0 y1) (of_int b)) 0%Z 8%Z)).

Axiom ByteW : forall (x:Numbers.BinNums.Z), char_t x -> ((bytew x) <= 8%Z)%Z.

(* Why3 assumption *)
Definition i_mem (p:Numbers.BinNums.Z) : Prop :=
  (ptr <= p)%Z /\ (p < (ptr + bytes)%Z)%Z.

(* Why3 assumption *)
Definition p_memw (p:Numbers.BinNums.Z) (b:Numbers.BinNums.Z) : Prop :=
  i_mem p /\ i_mem ((p + b)%Z - 1%Z)%Z.

Parameter memW: array Numbers.BinNums.Z.

Axiom MemW_init :
  forall (i:Numbers.BinNums.Z), i_mem i ->
  ((mixfix_lbrb memW i) = (bytew (mixfix_lbrb mem i))).

Parameter memw_i: Numbers.BinNums.Z -> Numbers.BinNums.Z.

Axiom memw_i'def :
  forall (p:Numbers.BinNums.Z), i_mem p ->
  ((memw_i p) = (bytew (mixfix_lbrb mem p))).

Parameter memw: Numbers.BinNums.Z -> Numbers.BinNums.Z -> Numbers.BinNums.Z.

Axiom memw'def :
  forall (p:Numbers.BinNums.Z) (bytes1:Numbers.BinNums.Z), p_memw p bytes1 ->
  ((memw p bytes1) =
   (sum (fun (y0:Numbers.BinNums.Z) => memw_i y0) p (p + bytes1)%Z)).

(* Why3 goal *)
Theorem MemW_sum :
  forall (p:Numbers.BinNums.Z) (x:Numbers.BinNums.Z), p_memw p x ->
  ((memw p x) <= (x * 8%Z)%Z)%Z.
Proof.
intros p x h1.

Qed.

